--------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.Std_Logic_1164.all;
USE IEEE.Std_Logic_Unsigned.all;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ENTITY Configurable_U256725 IS
  PORT(
      Q0   : OUT std_logic;
      R    : IN  std_logic;
      CEO  : OUT std_logic;
      TC   : OUT std_logic;
      CE   : IN  std_logic;
      C    : IN  std_logic
  );
END Configurable_U256725;
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
ARCHITECTURE structure OF Configurable_U256725 IS
--------------------------------------------------------------------------------
CONSTANT cMaxValue : std_logic := '1';
CONSTANT cMinValue : std_logic := '0';
SIGNAL Y : std_logic := cMinValue;
SIGNAL TC_int: std_logic;
--------------------------------------------------------------------------------
BEGIN
    PROCESS(C)
    BEGIN
        IF C'Event and C = '1' THEN
            IF R = '1' THEN
                Y <= cMinValue;
            ELSE
                IF (CE = '1') THEN
                    Y <= Y XOR '1';
                END IF;
            END IF;
        END IF;
    END PROCESS;
    TC_int <= '1' WHEN (Y = cMaxValue) ELSE
              '0';
    Q0 <= Y;
    TC <= TC_int;
    CEO <= TC_int AND CE;
END structure;
--------------------------------------------------------------------------------
